import socket
import threading

bindIp = "192.168.43.247"
bindPortArduino = 5587
bindPortNao = 6687
messaggio = ''

class Server():
    def __init__(self, name, port):
        server=socket.socket(socket.AF_INET, socket.SOCK_STREAM)
        server.setsockopt(socket.SOL_SOCKET, socket.SO_REUSEADDR, 1)
        server.bind((bindIp, port))
        server.listen(1)
        print("[*] Listening {} server on {}:{}".format(name, bindIp, port))

def arduino(clientSocket, address):
    global messaggio
    while True:
        try: 
            request = clientSocket.recv(1024)
            messaggio = request
            print("[*] Arduino ricevuto: {}".format(messaggio))
            if not request:
                break
        except (socket.error, KeyboardInterrupt):
            print("Connection Closed from: {}:{}".format(address[0], address[1]))
            break

def nao(clientSocket, address):
    global messaggio
    while True:
        if messaggio != '':
            clientSocket.send(messaggio)
            print("[*] Nao inviato: {}".format(messaggio))
            messaggio = ''                  

serverArduino = Server("Arduino", bindPortArduino)
serverNao = Server("Nao", bindPortNao)

while True:
    try:    
        clientArduino, addrArduino = serverArduino.accept()
        print("[*] Accepted connection from arduino {} {}".format(addrArduino[0], addrArduino[1]))
        clientHandlerArduino = threading.Thread(target = arduino, args = (clientArduino, addrArduino,))
        clientHandlerArduino.start()
        clientNao, addrNao = serverNao.accept()
        print("[*] Accepted connection from nao{} {}".format(addrNao[0], addrNao[1]))
        clientHandlerNao = threading.Thread(target = nao, args = (clientNao, addrNao,))
        clientHandlerNao.start()
    except (socket.error, KeyboardInterrupt):
        print("[*] All server are broken")
        break

clientArduino.close()
clientNao.close()
clientHandlerArduino.join()
clientHandlerNao.join()
